local TradeskillTimerLua_Frame, events = CreateFrame("FRAME"), {}
local TradeskillTimer_Timer = 0
local TradeskillTimer_Interval = .1
local TradeskillTimer_multiCastDelayCount = 0
local TradeskillTimer_Unlocked = false

if not TradeskillTimer then
	TradeskillTimer = {}
	TradeskillTimer.xOffset = -30
	TradeskillTimer.yOffset = -2
end

--------------------------------------------------------------------
function TradeskillTimer_Update(self, elapsed)
	TradeskillTimer_Timer = TradeskillTimer_Timer + elapsed
	if TradeskillTimer_Timer > TradeskillTimer_Interval then
		TradeskillTimer_Tick()
		TradeskillTimer_Timer = 0
	end
end

--------------------------------------------------------------------
function TradeskillTimer_Tick()
	if TradeskillTimer_Unlocked then
		TradeskillTimer_Text:SetText("00:00")
	else
		local _, _, _, _, spellStart, spellEnd, spellIsTradeskill = UnitCastingInfo("player")
		
		if spellIsTradeskill and TradeSkillFrame:IsVisible() then
			local currentNumRemaining = tonumber(TradeSkillFrame.DetailsFrame.CreateMultipleInputBox:GetText())
			local remainderTime = ceil((spellEnd - (GetTime() * 1000) + ((spellEnd - spellStart) * (currentNumRemaining - 1))) / 1000)
			
			-- Proper time format for remainder time
			local remainderString = ""
			if remainderTime >= 60 then
				remainderString = remainderString .. floor(remainderTime / 60) .. ":"
				remainderTime = remainderTime - (floor(remainderTime / 60) * 60)
			end
			if remainderTime < 10 and remainderString ~= "" then remainderString = remainderString .. "0" end
			remainderString = remainderString .. remainderTime

			TradeskillTimer_Text:SetText(remainderString)
			
			if currentNumRemaining and currentNumRemaining > 1 then TradeskillTimer_multiCastDelayCount = 3 end
		else
			if TradeskillTimer_multiCastDelayCount > 0 and currentNumRemaining and currentNumRemaining <= 1 then
				TradeskillTimer_multiCastDelayCount = TradeskillTimer_multiCastDelayCount - 1
			end
			
			if TradeskillTimer_multiCastDelayCount <= 0 then TradeskillTimer_Text:SetText("") end
		end
	end
end

function events:ADDON_LOADED(...)
	local addonName = ...
	if addonName == "TradeskillTimer" then
		TradeskillTimer_Init()
		TradeskillTimerLua_Frame:UnregisterEvent("ADDON_LOADED")
	end
end

--------------------------------------------------------------------
TradeskillTimerLua_Frame:SetScript("OnEvent", function(self, event, ...)
	events[event](self, ...)
end)

--------------------------------------------------------------------
for i, v in pairs(events) do
	TradeskillTimerLua_Frame:RegisterEvent(i)
end


function TradeskillTimer_Init()
	TradeskillTimer_Frame:RegisterForDrag("LeftButton")

	if not TradeskillTimer then
		TradeskillTimer = {}
		TradeskillTimer.xOffset = -30
		TradeskillTimer.yOffset = -2
	else
		TradeskillTimer_Frame:SetPoint("TOPRIGHT", TradeskillTimer.xOffset, TradeskillTimer.yOffset)
	end
end
--------------------------------------------------------------------
--	Slash Command: TRADESKILLTIMER
--	Toggles lock/unlock of TradeskillTimer frame
--
--	PARAMETERS:
--	msg - Unused. Required by slash command functions.
--	editbox - Unused. Required by slash command functions.
--
SLASH_TRADESKILLTIMER1 = '/tradeskilltimer';
function SlashCmdList.TRADESKILLTIMER(msg, editbox)
	TradeskillTimer_Unlocked = not TradeskillTimer_Unlocked
	if TradeskillTimer_Unlocked then
		DEFAULT_CHAT_FRAME:AddMessage("Tradeskill Timer has been unlocked and can be dragged to a new position.")
		TradeskillTimer_Frame:EnableMouse(true);
		TradeskillTimer_FrameBackground:SetTexture(1, 1, 1, .3);
	else
		DEFAULT_CHAT_FRAME:AddMessage("Tradeskill Timer has been locked.")
		TradeskillTimer_FrameBackground:SetTexture(1, 1, 1, 0);
		TradeskillTimer_Frame:EnableMouse(false);
		TradeskillTimer_Frame:StopMovingOrSizing()
	end
end

function TradeskillTimer_DragStart(frameName)
	if TradeskillTimer_Unlocked then frameName:StartMoving() end
end

function TradeskillTimer_DragStop(frameName)
	frameName:StopMovingOrSizing()
	TradeskillTimer.xOffset = TradeskillTimer_Frame:GetRight() - TradeSkillFrame:GetRight()
	TradeskillTimer.yOffset = TradeskillTimer_Frame:GetTop() - TradeSkillFrame:GetTop()
end